import os 
import shutil
import subprocess

class fmanager:
    def list_files(directory):
        try:
            files = os.listdir(directory)
            for file in files:
                print(file)
        except OSError as error:
            print(f"FME Error: Failed to list files from '{directory}'. {error}")

    def create_directory(directory_name):
        try:
            os.makedirs(directory_name)
        except OSError as error:
            print(f"FME Error: Failed to create directory '{directory_name}'. {error}")

    def delete_file(file_path):
        try:
            os.remove(file_path)
        except OSError as error:
            print(f"FME Error: Failed to delete file '{file_path}'. {error}")

    def copy_file(source, destination):
        try:
            shutil.copy(source, destination)
        except OSError as error:
            print(f"FME Error: Failed to copy file '{source}' to '{destination}'. {error}")

    def move_file(source, destination):
        try:
            shutil.move(source, destination)
        except OSError as error:
            print(f"FME Error: Failed to move file '{source}' to '{destination}'. {error}")

    def list_current_directory():
        try:
            current_directory = os.getcwd()
            print("Current Directory is:", current_directory)
        except OSError as error:
            print(f"FME Error: Failed to list the current directory. {error}")


    def rename_file(current_name, new_name):
        try: 
            os.rename(current_name, new_name)
        except OSError as error:
            print(f"FME Error: Failed to rename file '{current_name}' to '{new_name}'. {error}")

    def delete_directory(directory):
        try:
            shutil.rmtree(directory)
            print(f"Directory '{directory}' deleted")
        except OSError as error:
            print(f"FME Error: Failed to delete directory '{directory}'. {error}")

    def list_installed_applications():
        command = "system_profiler SPApplicationsDataType | grep -i 'Location: /Applications' | awk -F'/' '{print $NF}'"
        process = subprocess.Popen(command, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE)
        output, error = process.communicate()
        if process.returncode == 0:
            app_list = output.decode("utf-8").strip().split("\n")
            for app in app_list:
                print(app)
        else:
            print("Error:", error.decode("utf-8"))

